import { app, router } from './index.ts';
import { useConfig } from '@kevisual/use-config/env';
import './route.ts';
import './simple-routes/index.ts';
app
  .route({
    path: 'user',
    key: 'me',
  })
  .define(async (ctx) => {
    ctx.body = {
      id: '14206305-8b5c-44cc-b177-766cfe2e452f',
      username: 'root',
      nickname: null,
      description: null,
      needChangePassword: true,
      type: 'user',
      avatar: '/root/center/panda.png',
      orgs: ['web', 'workspace', 'ai', 'admin', 'system', 'silkyai', 'apps', 'tailored', 'user', 'ui', 'docs', 'resume'],
    };
  })
  .addTo(app);
app
  .route({
    path: 'auth',
    id: 'auth',
  })
  .define(async (ctx) => {
    ctx.query.token = '123';
    ctx.state.tokenUser = {
      id: '14206305-8b5c-44cc-b177-766cfe2e452f',
      username: 'routerContext',
    };
  })
  .addTo(app);

app
  .route({
    path: 'auth-admin',
    id: 'auth-admin',
  })
  .define(async (ctx) => {
    ctx.body = '123';
    ctx.state.tokenUser = {
      id: '14206305-8b5c-44cc-b177-766cfe2e452f',
      username: 'root',
      orgs: ['admin'],
    };
  })
  .addTo(app);
app
  .route({
    path: 'demo',
    key: 'demo',
  })
  .define(async (ctx) => {
    ctx.body = '123';
  })
  .addTo(app);

const config = useConfig();
const port = config.PORT || 4000;

console.log('run demo: http://localhost:' + port + '/api/router?path=demo&key=demo');

app.listen(port, () => {
  console.log(`server is running at http://localhost:${port}`);
});

app.server.on((req, res) => {
  const url = new URL(req.url, 'http://localhost');
  const pathname = url.pathname;
  router.parse(req, res);
});
