import { app } from '@/app.ts';
import * as aliPay from './alipay/pay.ts';
import { TradeModel } from '../trade/model.ts';

// https://kevisual.cn/api/router?path=alipay&key=pay
app
  .route({
    path: 'alipay',
    key: 'pay',
  })
  .define(async (ctx) => {
    const { money, subject = '支付', out_trade_no } = ctx.query.data || {};
    if (!money || !subject) {
      ctx.throw(400, 'money or subject is required');
    }
    if (isNaN(Number(money))) {
      ctx.throw(400, 'money must be a number');
    }
    const result = await aliPay.pay({
      out_trade_no: out_trade_no || aliPay.genOutTradeNo(),
      money: money,
      subject: subject,
    });
    ctx.body = result;
  })
  .addTo(app);
