export type TradeState = 'SUCCESS' | 'REFUND' | 'NOTPAY' | 'CLOSED' | 'REVOKED' | 'USERPAYING' | 'PAYERROR';
//  WAIT_BUYER_PAY, TRADE_SUCCESS, TRADE_CLOSED, TRADE_FINISHED
import { TradeStatus } from '../alipay/notify.ts';

export const wxStateToAlipayState: Record<TradeState, TradeStatus> = {
  SUCCESS: TradeStatus.TRADE_SUCCESS,
  CLOSED: TradeStatus.TRADE_CLOSED,
  REFUND: TradeStatus.TRADE_CLOSED,
  NOTPAY: TradeStatus.WAIT_BUYER_PAY,
  REVOKED: TradeStatus.TRADE_CLOSED,
  USERPAYING: TradeStatus.WAIT_BUYER_PAY,
  PAYERROR: TradeStatus.TRADE_CLOSED,
};
export type WechatpayNotify = {
  transaction_id: string;
  amount: {
    payer_total: number;
    total: number;
    currency: string;
    payer_currency: string;
  };
  mchid: string;
  trade_state: string;
  bank_type: string;
  promotion_detail: {
    amount: number;
    wechatpay_contribute: number;
    coupon_id: string;
    scope: string;
    merchant_contribute: number;
    name: string;
    other_contribute: number;
    currency: string;
    stock_id: string;
    goods_detail: {
      goods_remark: string;
      quantity: number;
      discount_amount: number;
      goods_id: string;
      unit_price: number;
    }[];
  }[];
  success_time: string;
  payer: {
    openid: string;
  };
  out_trade_no: string;
  appid: string;
  trade_state_desc: string;
  trade_type: string;
  attach: string;
  scene_info: {
    device_id: string;
  };
};
