import { app } from '@/app.ts';
import { getPaymentQRCode } from './wechatpay/init.ts';
import { log } from '@/logger/index.ts';

app
  .route({
    path: 'wx',
    key: 'pay',
  })
  .define(async (ctx) => {
    const { money, subject = '支付', out_trade_no } = ctx.query.data || {};
    if (!money || !subject) {
      ctx.throw(400, 'money or subject is required');
    }
    log.info('getPaymentQRCode', {
      money,
      subject,
      out_trade_no,
    });
    const result = await getPaymentQRCode({
      amount: money,
      subject,
      out_trade_no: out_trade_no,
    });
    ctx.body = result;
  })
  .addTo(app);
