import { log } from '@/logger/index.ts';
import { IncomingMessage, OutgoingMessage } from 'http';

// gmt_create=2025-02-12+14%3A57%3A18&charset=utf-8&gmt_payment=2025-02-12+14%3A57%3A26&notify_time=2025-02-12+14%3A57%3A27&subject=test&sign=IcqgLJn6HzUpd6so2lPCWm%2FOn%2BEHa8pPLrQVfiOszWB1BjR0MkPommx5esva6nIktJGFU3d2s8%2B1Q%2FfKH8dQcdkjVOI63szQCYnvhFP0AVUKfRTDj8xlRo5rjBg5I3b5aOAOgA4ZgVJanJAIq98qK5CVfKSwdTQTpKHXVpV15%2Fu1EJyE14Ptj3H83J6hpeK9EFWKbZsEkZIb2pR3calk3HIeLkPo4FvWo6q38gUjk3wrLBTh%2B0RhxItCKF3%2B58R9rmzk4WX4S71cBb6w9kBuyA29flawzb6d4qqHzRzqlhid7I0QFgRKRHTnyajlahFCe3kOeWgYfQRpKLabaznQqA%3D%3D&buyer_id=2088722055631717&invoice_amount=1.00&version=1.0&notify_id=2025021201222145726131710505339992&fund_bill_list=%5B%7B%22amount%22%3A%221.00%22%2C%22fundChannel%22%3A%22ALIPAYACCOUNT%22%7D%5D&notify_type=trade_status_sync&out_trade_no=1739343435250&total_amount=1.00&trade_status=TRADE_SUCCESS&trade_no=2025021222001431710505292165&auth_app_id=9021000143661256&receipt_amount=1.00&point_amount=0.00&buyer_pay_amount=1.00&app_id=9021000143661256&sign_type=RSA2&seller_id=2088721055593715
export const getJsonUseFrom = (str: string) => {
  const urlParams = new URLSearchParams(str);
  const entries = urlParams.entries();
  const result = {};
  for (const [key, value] of entries) {
    result[key] = value;
  }
  return result;
};
export const parseBody = async (req: IncomingMessage, res: OutgoingMessage) => {
  let body = '';
  req.on('data', (chunk: any) => {
    body += chunk;
  });
  return new Promise<any>((resolve, reject) => {
    req.on('end', () => {
      const contentType = req.headers['content-type'];
      try {
        if (contentType && contentType.includes('application/x-www-form-urlencoded')) {
          resolve(getJsonUseFrom(body));
        } else if (contentType && contentType.includes('application/json')) {
          resolve(JSON.parse(body));
        } else {
          reject(new Error('Unsupported content type'));
        }
      } catch (error) {
        log.error('getBody error', {
          message: error.message,
          stack: error.stack,
        });
        reject(error);
      }
    });
  });
};
